

<!DOCTYPE html>
<!--[if IE 8]><html class="no-js lt-ie9" lang="en" > <![endif]-->
<!--[if gt IE 8]><!--> <html class="no-js" lang="en" > <!--<![endif]-->
<head>
  <meta charset="utf-8">
  
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  
  <title>Hypercall ABI &mdash; Xen 4.16-unstable documentation</title>
  

  
  
  
  

  

  
  
    

  

  
  
    <link rel="stylesheet" href="../../_static/css/theme.css" type="text/css" />
  

  

  
        <link rel="index" title="Index"
              href="../../genindex.html"/>
        <link rel="search" title="Search" href="../../search.html"/>
    <link rel="top" title="Xen 4.16-unstable documentation" href="../../index.html"/>
        <link rel="up" title="x86" href="index.html"/>
        <link rel="next" title="Hypervisor documentation" href="../../hypervisor-guide/index.html"/>
        <link rel="prev" title="x86" href="index.html"/> 

  
  <script src="../../_static/js/modernizr.min.js"></script>

</head>

<body class="wy-body-for-nav" role="document">

   
  <div class="wy-grid-for-nav">

    
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search">
          

          
            <a href="../../index.html" class="icon icon-home"> Xen
          

          
          </a>

          
            
            
              <div class="version">
                4.16
              </div>
            
          

          
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="../../search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>

          
        </div>

        <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="main navigation">
          
            
            
              
            
            
              <ul>
<li class="toctree-l1"><a class="reference internal" href="../../admin-guide/index.html">Admin Guide</a></li>
</ul>
<ul class="current">
<li class="toctree-l1 current"><a class="reference internal" href="../index.html">Guest documentation</a><ul class="current">
<li class="toctree-l2 current"><a class="reference internal" href="index.html">x86</a><ul class="current">
<li class="toctree-l3 current"><a class="current reference internal" href="#">Hypercall ABI</a><ul>
<li class="toctree-l4"><a class="reference internal" href="#registers">Registers</a></li>
<li class="toctree-l4"><a class="reference internal" href="#parameters">Parameters</a></li>
<li class="toctree-l4"><a class="reference internal" href="#mode-transfer">Mode transfer</a></li>
</ul>
</li>
<li class="toctree-l3"><a class="reference internal" href="#hypercall-page">Hypercall Page</a><ul>
<li class="toctree-l4"><a class="reference internal" href="#creating-hypercall-pages">Creating Hypercall Pages</a></li>
</ul>
</li>
</ul>
</li>
</ul>
</li>
</ul>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../hypervisor-guide/index.html">Hypervisor documentation</a></li>
</ul>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../hypercall-interfaces/index.html">Hypercall Interfaces</a></li>
</ul>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../glossary.html">Glossary</a></li>
</ul>

            
          
        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">

      
      <nav class="wy-nav-top" role="navigation" aria-label="top navigation">
        
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="../../index.html">Xen</a>
        
      </nav>


      
      <div class="wy-nav-content">
        <div class="rst-content">
          















<div role="navigation" aria-label="breadcrumbs navigation">

  <ul class="wy-breadcrumbs">
    
      <li><a href="../../index.html">Docs</a> &raquo;</li>
        
          <li><a href="../index.html">Guest documentation</a> &raquo;</li>
        
          <li><a href="index.html">x86</a> &raquo;</li>
        
      <li>Hypercall ABI</li>
    
    
      <li class="wy-breadcrumbs-aside">
        
            
            <a href="../../_sources/guest-guide/x86/hypercall-abi.rst.txt" rel="nofollow"> View page source</a>
          
        
      </li>
    
  </ul>

  
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
            
  <div class="section" id="hypercall-abi">
<h1>Hypercall ABI<a class="headerlink" href="#hypercall-abi" title="Permalink to this headline">¶</a></h1>
<p>Hypercalls are system calls to Xen.  Two modes of guest operation are
supported, and up to 6 individual parameters are supported.</p>
<p>Hypercalls may only be issued by kernel-level software <a class="footnote-reference" href="#id4" id="id1">[1]</a>.</p>
<div class="section" id="registers">
<h2>Registers<a class="headerlink" href="#registers" title="Permalink to this headline">¶</a></h2>
<p>The registers used for hypercalls depends on the operating mode of the guest.</p>
<table border="1" class="docutils">
<colgroup>
<col width="25%" />
<col width="25%" />
<col width="25%" />
<col width="25%" />
</colgroup>
<thead valign="bottom">
<tr class="row-odd"><th class="head">ABI</th>
<th class="head">Hypercall Index</th>
<th class="head">Parameters (1 - 6)</th>
<th class="head">Result</th>
</tr>
</thead>
<tbody valign="top">
<tr class="row-even"><td>64bit</td>
<td>RAX</td>
<td>RDI RSI RDX R10 R8 R9</td>
<td>RAX</td>
</tr>
<tr class="row-odd"><td>32bit</td>
<td>EAX</td>
<td>EBX ECX EDX ESI EDI EBP</td>
<td>EAX</td>
</tr>
</tbody>
</table>
<p>32 and 64bit PV guests have an ABI fixed by their guest type.  The ABI for an
HVM guest depends on whether the vCPU is operating in a 64bit segment or not
<a class="footnote-reference" href="#id5" id="id2">[2]</a>.</p>
</div>
<div class="section" id="parameters">
<h2>Parameters<a class="headerlink" href="#parameters" title="Permalink to this headline">¶</a></h2>
<p>Different hypercalls take a different number of parameters.  Each hypercall
potentially clobbers each of its parameter registers; a guest may not rely on
the parameter registers staying the same.  A debug build of Xen checks this by
deliberately poisoning the parameter registers before returning back to the
guest.</p>
</div>
<div class="section" id="mode-transfer">
<h2>Mode transfer<a class="headerlink" href="#mode-transfer" title="Permalink to this headline">¶</a></h2>
<p>The exact sequence of instructions required to issue a hypercall differs
between virtualisation mode and hardware vendor.</p>
<table border="1" class="docutils">
<colgroup>
<col width="50%" />
<col width="50%" />
</colgroup>
<thead valign="bottom">
<tr class="row-odd"><th class="head">Guest</th>
<th class="head">Transfer instruction</th>
</tr>
</thead>
<tbody valign="top">
<tr class="row-even"><td>32bit PV</td>
<td>INT 0x82</td>
</tr>
<tr class="row-odd"><td>64bit PV</td>
<td>SYSCALL</td>
</tr>
<tr class="row-even"><td>Intel HVM</td>
<td>VMCALL</td>
</tr>
<tr class="row-odd"><td>AMD HVM</td>
<td>VMMCALL</td>
</tr>
</tbody>
</table>
<p>To abstract away the details, Xen implements an interface known as the
Hypercall Page.  This allows a guest to make a hypercall without needing to
perform mode-specific or vendor-specific setup.</p>
</div>
</div>
<div class="section" id="hypercall-page">
<h1>Hypercall Page<a class="headerlink" href="#hypercall-page" title="Permalink to this headline">¶</a></h1>
<p>The hypercall page is a page of guest RAM into which Xen will write suitable
transfer stubs.</p>
<p>Creating a hypercall page is an isolated operation from Xen’s point of view.
It is the guests responsibility to ensure that the hypercall page, once
written by Xen, is mapped with executable permissions so it may be used.
Multiple hypercall pages may be created by the guest, if it wishes.</p>
<p>The stubs are arranged by hypercall index, and start on 32-byte boundaries.
To invoke a specific hypercall, <code class="docutils literal"><span class="pre">call</span></code> the relevant stub <a class="footnote-reference" href="#id6" id="id3">[3]</a>:</p>
<div class="highlight-none"><div class="highlight"><pre><span></span>call hypercall_page + index * 32
</pre></div>
</div>
<p>There result is an ABI which is invariant of the exact operating mode or
hardware vendor.  This is intended to simplify guest kernel interfaces by
abstracting away the details of how it is currently running.</p>
<div class="section" id="creating-hypercall-pages">
<h2>Creating Hypercall Pages<a class="headerlink" href="#creating-hypercall-pages" title="Permalink to this headline">¶</a></h2>
<p>Guests which are started using the PV boot protocol may set set
<code class="docutils literal"><span class="pre">XEN_ELFNOTE_HYPERCALL_PAGE</span></code> to have the nominated page written as a
hypercall page during construction.  This mechanism is common for PV guests,
and allows hypercalls to be issued with no additional setup.</p>
<p>Any guest can locate the Xen CPUID leaves and read the <em>hypercall transfer
page</em> information, which specifies an MSR that can be used to create
additional hypercall pages.  When a guest physical address is written to the
MSR, Xen writes a hypercall page into the nominated guest page.  This
mechanism is common for HVM guests which are typically started via legacy
means.</p>
<p class="rubric">Footnotes</p>
<table class="docutils footnote" frame="void" id="id4" rules="none">
<colgroup><col class="label" /><col /></colgroup>
<tbody valign="top">
<tr><td class="label"><a class="fn-backref" href="#id1">[1]</a></td><td>For HVM guests, <code class="docutils literal"><span class="pre">HVMOP_guest_request_vm_event</span></code> may be configured to
be usable from userspace, but this behaviour is not default.</td></tr>
</tbody>
</table>
<table class="docutils footnote" frame="void" id="id5" rules="none">
<colgroup><col class="label" /><col /></colgroup>
<tbody valign="top">
<tr><td class="label"><a class="fn-backref" href="#id2">[2]</a></td><td>While it is possible to use compatibility mode segments in a 64bit
kernel, hypercalls issues from such a mode will be interpreted with the
32bit ABI.  Such a setup is not expected in production scenarios.</td></tr>
</tbody>
</table>
<table class="docutils footnote" frame="void" id="id6" rules="none">
<colgroup><col class="label" /><col /></colgroup>
<tbody valign="top">
<tr><td class="label"><a class="fn-backref" href="#id3">[3]</a></td><td><code class="docutils literal"><span class="pre">HYPERCALL_iret</span></code> is special.  It is only implemented for PV guests
and takes all its parameters on the stack.  This stub should be
<code class="docutils literal"><span class="pre">jmp</span></code>’d to, rather than <code class="docutils literal"><span class="pre">call</span></code>’d.  HVM guests have this stub
implemented as <code class="docutils literal"><span class="pre">ud2a</span></code> to prevent accidental use.</td></tr>
</tbody>
</table>
</div>
</div>


           </div>
           <div class="articleComments">
            
           </div>
          </div>
          <footer>
  
    <div class="rst-footer-buttons" role="navigation" aria-label="footer navigation">
      
        <a href="../../hypervisor-guide/index.html" class="btn btn-neutral float-right" title="Hypervisor documentation" accesskey="n" rel="next">Next <span class="fa fa-arrow-circle-right"></span></a>
      
      
        <a href="index.html" class="btn btn-neutral" title="x86" accesskey="p" rel="prev"><span class="fa fa-arrow-circle-left"></span> Previous</a>
      
    </div>
  

  <hr/>

  <div role="contentinfo">
    <p>
        &copy; Copyright 2019, The Xen development community.

    </p>
  </div>
  Built with <a href="http://sphinx-doc.org/">Sphinx</a> using a <a href="https://github.com/snide/sphinx_rtd_theme">theme</a> provided by <a href="https://readthedocs.org">Read the Docs</a>. 

</footer>

        </div>
      </div>

    </section>

  </div>
  


  

    <script type="text/javascript">
        var DOCUMENTATION_OPTIONS = {
            URL_ROOT:'../../',
            VERSION:'4.16-unstable',
            COLLAPSE_INDEX:false,
            FILE_SUFFIX:'.html',
            HAS_SOURCE:  true,
            SOURCELINK_SUFFIX: '.txt'
        };
    </script>
      <script type="text/javascript" src="../../_static/jquery.js"></script>
      <script type="text/javascript" src="../../_static/underscore.js"></script>
      <script type="text/javascript" src="../../_static/doctools.js"></script>

  

  
  
    <script type="text/javascript" src="../../_static/js/theme.js"></script>
  

  
  
  <script type="text/javascript">
      jQuery(function () {
          SphinxRtdTheme.StickyNav.enable();
      });
  </script>
   

</body>
</html>